<template>
  <div
    class="i-unlock-full-access"
    :class="{
      'i-unlock-full-access--shown': isShown,
      'i-unlock-full-access--variant-0': variant === 0,
      'i-unlock-full-access--variant-1': variant === 1,
      'i-unlock-full-access--variant-2': variant === 2,
    }">
    <div class="i-unlock-full-access__background"></div>
    <div v-if="status === 'success'" class="i-unlock-full-access__wrapper">
      <div class="i-unlock-full-access__content">
        <div class="i-unlock-full-access-checking">
          <span class="i-unlock-full-access-checking__title">{{ $t(`Checking`) }}...</span>
          <img src="~assets/images/spinner-black.svg" class="i-unlock-full-access-checking__image" />
        </div>
      </div>
    </div>
    <div v-else-if="variant === 0" class="i-unlock-full-access__wrapper">
      <div class="i-unlock-full-access__content">
        <div class="i-unlock-full-access__title">{{ $t(`Unlock Full Access`) }}</div>
        <button v-if="cross" class="i-unlock-full-access__cross" @click="hide()" />
        <div class="i-unlock-full-access__details">
          <div class="i-unlock-full-access__detail">{{ $t(`Hyper-personalized horoscope & charts`) }}</div>
          <div class="i-unlock-full-access__detail">{{ $t(`Real time planets position`) }}</div>
          <div class="i-unlock-full-access__detail">{{ $t(`High-accurate compatibility report`) }}</div>
          <div class="i-unlock-full-access__detail">{{ $t(`No ads`) }}</div>
        </div>
        <div class="i-unlock-full-access__description">
          <div>
            {{ $t(`Then`) }} {{ subscriptionPriceFormatted }} {{ subscriptionPriceCurrency }}/{{
              subscriptionPriceInterval
            }}.
          </div>
          <div>{{ $t(`No commitment. Cancel anytime.`) }}</div>
        </div>
        <i-button block @click="tryFreeTrial()" :loading="isLoading" :disabled="isLoading">
          {{ $t(`Try`) }} {{ subscriptionPriceTrialPeriodText }} {{ $t(`Free Trial`) }}
        </i-button>
        <div class="i-unblock-full-access__terms">
          <nuxt-link :to="{ name: 'terms-and-conditions' }" class="i-unblock-full-access__term">
            {{ $t(`Terms of Use`) }}
          </nuxt-link>
          <span class="i-unblock-full-access__term-separator" />
          <nuxt-link :to="{ name: 'privacy-policy' }" class="i-unblock-full-access__term">
            {{ $t(`Privacy Policy`) }}
          </nuxt-link>
        </div>
        <div class="i-unblock-full-access__circles">
          <img src="~assets/images/circles-orange.svg" class="circles circles--bottomBack" />
        </div>
      </div>
    </div>
    <div v-else-if="variant === 1" class="i-unlock-full-access__wrapper">
      <div class="i-unlock-full-access__content">
        <div class="i-unlock-full-access__overlay">
          <img src="~assets/images/scientist-telescope.png" class="i-unlock-full-access__image" />
          <div class="i-unlock-full-access__title">{{ $t(`Join our community`) }}</div>
          <div class="i-unlock-full-access__description">
            {{ $t(`Become a member and got unlimited access to all functions of this app`) }}
          </div>
          <img src="~assets/images/i-unlock-full-access-decorations.svg" class="i-unlock-full-access__decorations" />
        </div>
        <div class="i-unlock-full-access-info">
          <div class="i-unlock-full-access-info__content">
            <div class="i-unlock-full-access-info__title">{{ $t(`Free Trial`) }}</div>
            <div class="i-unlock-full-access-info__tag">{{ subscriptionPriceTrialPeriodText.toLowerCase() }}</div>
            <div class="i-unlock-full-access-info__description">
              {{ $t(`Then`) }}
              <span class="highlighted">{{ subscriptionPriceFormatted }} {{ subscriptionPriceCurrency }}</span
              >/{{ subscriptionPriceInterval }}.<br />{{ $t(`No commitment. Easily cancel anytime.`) }}
            </div>
          </div>
          <div class="i-unlock-full-access-info__shadow" />
        </div>
        <div class="i-unlock-full-access__details">
          <div class="i-unlock-full-access-detail">
            <img src="~assets/images/i-unlock-full-access-1-detail-1.svg" class="i-unlock-full-access-detail__image" />
            <span class="i-unlock-full-access-detail__title">{{ $t(`Hyper-personalized horoscope & charts`) }}</span>
          </div>
          <div class="i-unlock-full-access-detail">
            <img src="~assets/images/i-unlock-full-access-1-detail-2.svg" class="i-unlock-full-access-detail__image" />
            <span class="i-unlock-full-access-detail__title">{{ $t(`Real time planets position`) }}</span>
          </div>
          <div class="i-unlock-full-access-detail">
            <img src="~assets/images/i-unlock-full-access-1-detail-3.svg" class="i-unlock-full-access-detail__image" />
            <span class="i-unlock-full-access-detail__title">{{ $t(`High-accurate compatibility report`) }}</span>
          </div>
        </div>
        <div class="i-unlock-full-access__button-wrapper">
          <i-button block @click="tryFreeTrial()" :loading="isLoading" :disabled="isLoading">
            {{ $t(`CONTINUE`) }}
          </i-button>
        </div>
        <div class="i-unblock-full-access__terms">
          <nuxt-link :to="{ name: 'terms-and-conditions' }" class="i-unblock-full-access__term">
            {{ $t(`Terms of Use`) }}
          </nuxt-link>
          <span class="i-unblock-full-access__term-separator" />
          <nuxt-link :to="{ name: 'privacy-policy' }" class="i-unblock-full-access__term">
            {{ $t(`Privacy Policy`) }}
          </nuxt-link>
        </div>
        <div class="i-unblock-full-access__circles">
          <img src="~assets/images/circles-orange.svg" class="circles circles--bottomBack" />
        </div>
      </div>
    </div>
    <div v-else-if="variant === 2" class="i-unlock-full-access__wrapper">
      <div class="i-unlock-full-access__content">
        <div class="i-unlock-full-access__title">{{ $t(`Unlock Full Access`) }}</div>
        <button v-if="cross" class="i-unlock-full-access__cross" @click="hide()" />
        <div class="i-unlock-full-access__details">
          <div class="i-unlock-full-access__detail">{{ $t(`Hyper-personalized horoscope & charts`) }}</div>
          <div class="i-unlock-full-access__detail">{{ $t(`Real time planets position`) }}</div>
          <div class="i-unlock-full-access__detail">{{ $t(`High-accurate compatibility report`) }}</div>
        </div>
        <div class="i-unlock-full-access-info">
          <div class="i-unlock-full-access-info__title">{{ $t(`Free Trial`) }}</div>
          <div class="i-unlock-full-access-info__stars">
            <img
              v-for="i in 5"
              :key="i"
              src="~assets/images/i-unlock-full-access-start.svg"
              class="i-unlock-full-access-info__star" />
          </div>
          <div class="i-unlock-full-access-info__separator" />
          <div class="i-unlock-full-access-info__steps">
            <div class="i-unlock-full-access-info__step">{{ $t(`Easily cancel anytime`) }}</div>
            <div class="i-unlock-full-access-info__step">
              <span>
                {{ subscriptionPriceTrialPeriodText.toLowerCase() }} {{ $t(`free`) }} & {{ $t(`then`) }}
                <span class="highlighted">{{ subscriptionPriceFormatted }} {{ subscriptionPriceCurrency }}</span
                >/{{ subscriptionPriceInterval }}
              </span>
            </div>
          </div>
        </div>
        <i-button block @click="tryFreeTrial()" :loading="isLoading" :disabled="isLoading">
          {{ $t(`CONTINUE`) }}
        </i-button>
        <div class="i-unblock-full-access__terms">
          <nuxt-link :to="{ name: 'terms-and-conditions' }" class="i-unblock-full-access__term">
            {{ $t(`Terms of Use`) }}
          </nuxt-link>
          <span class="i-unblock-full-access__term-separator" />
          <nuxt-link :to="{ name: 'privacy-policy' }" class="i-unblock-full-access__term">
            {{ $t(`Privacy Policy`) }}
          </nuxt-link>
        </div>
        <div class="i-unblock-full-access__circles">
          <img src="~assets/images/circles-orange.svg" class="circles circles--bottomBack" />
        </div>
      </div>
    </div>
  </div>
</template>

<script>
  import { mapState } from 'vuex';

  export default {
    props: {
      cross: Boolean,
    },

    data() {
      return {
        stripe: null,
        canMakePayment: null,
        paymentRequest: null,
        paymentMethod: null,
        isLoading: false,
        isShown: !!this.$route.query.iufa,
        isMounted: false,
        isValidating: this.$route.query.iufa === 'success',
        nuxtElement: null,
        variant: null,
      };
    },

    computed: {
      ...mapState(['auth']),

      status() {
        return this.$route.query.iufa || null;
      },

      subscriptionPriceFormatted() {
        return this.auth.stripe.subscriptionPrice.amount.toLocaleString('UK');
      },

      subscriptionPriceCurrency() {
        return this.auth.stripe.subscriptionPrice.currency;
      },

      subscriptionPriceInterval() {
        return [
          this.auth.stripe.subscriptionPrice.interval[0].toUpperCase(),
          this.auth.stripe.subscriptionPrice.interval.slice(1),
        ].join('');
      },

      subscriptionPriceTrialPeriodText() {
        if (this.auth.stripe.subscriptionPrice.trialDays === 7) {
          return '1 Week';
        }

        return `${this.auth.stripe.subscriptionPrice.trialDays} Days`;
      },
    },

    // watch: {
    //   isShown() {
    //     if (this.isShown && this.isMounted) {
    //       this.nuxtElement.style.overflow = 'hidden';
    //       this.nuxtElement.freezersCount = (this.nuxtElement.freezersCount || 0) + 1;
    //     }
    //   },
    // },

    async mounted() {
      this.isMounted = true;
      this.nuxtElement = document.querySelector('#__nuxt');

      if (this.$exp.name === 'subscription-page') {
        this.variant = this.$exp.$variantIndexes[0];
      } else {
        this.variant = 0;
      }

      if (!this.auth.user) {
        return;
      }

      if (this.auth.user.hasActiveSubscription) {
        return;
      }

      if (this.isShown) {
        this.nuxtElement.style.overflow = 'hidden';
      }

      if (this.status === 'success') {
        return this.validate();
      }

      if (this.status) {
        alert('Something went wrong. Please, try again.');
      }

      this.stripe = Stripe(this.auth.stripe.publicKey);

      this.paymentRequest = this.stripe.paymentRequest({
        country: 'CY',
        currency: this.auth.stripe.subscriptionPrice.currency.toLowerCase(),
        total: {
          label: 'Total',
          amount: 0, // this.auth.stripe.subscriptionPrice.amount * 100,
        },
        displayItems: [
          {
            label: `${this.subscriptionPriceTrialPeriodText} Free Trial`,
            amount: 0,
          },
        ],
        requestPayerName: true,
        requestPayerEmail: true,
      });

      this.paymentRequest.on('paymentmethod', async (event) => {
        this.paymentMethod = event.paymentMethod;

        let response = await this.$axios.post(`users/me/subscription/create`, {
          stripePaymentMethodId: this.paymentMethod.id,
        });

        event.complete('success');
        this.hide();

        if (response.data.data.hasActiveSubscription) {
          this.$store.commit('MERGE_AUTH', {
            user: { hasActiveSubscription: true },
          });

          fbq('track', 'StartTrial');
          ga('send', 'event', 'start_trial');
        }

        setTimeout(() => {
          if (response.data.data.hasBeenSubscribed) {
            alert('You have been subscribed!');
          } else if (response.data.data.hasActiveSubscription) {
            alert('You already subscribed.');
          } else {
            alert('Something went wrong. Please, try again.');
          }
        }, 1000);
      });

      this.canMakePayment = !!(await this.paymentRequest.canMakePayment());
    },

    beforeDestroy() {
      if (this.isShown) {
        this.nuxtElement.style.overflow = '';
        this.isShown = false;
      }
    },

    methods: {
      show() {
        this.isShown = true;
        this.isLoading = false;
        this.nuxtElement.style.overflow = 'hidden';
      },

      async hide() {
        this.isShown = false;
        this.nuxtElement.style.overflow = '';

        if (!this.auth.user.unlockFullAccessClosedAt) {
          let response = await this.$axios.post(`users/me/unlock_full_access_closed`);
          this.$store.commit('MERGE_AUTH', { user: response.data.data });
        }

        this.$emit('hide');
      },

      async validate() {
        try {
          let response = await this.$axios.post(`users/me/subscription/validate`, {
            stripeCheckoutSessionId: this.$route.query.scsi,
          });

          if (!response.data.data.hasActiveSubscription) {
            setTimeout(this.validate, 2500);
            return;
          }

          this.$store.commit('MERGE_AUTH', { user: response.data.data });
          fbq('track', 'StartTrial');
          ga('send', 'event', 'start_trial');
          alert('You have been subscribed!');
          await this.hide();

          setTimeout(() => {
            this.$router.replace({ name: this.$route.name, params: this.$route.params, query: {} });
          }, 250);
        } catch (error) {
          console.error(error);
          setTimeout(this.validate, 2500);
        }
      },

      async tryFreeTrial() {
        if (this.canMakePayment) {
          this.paymentRequest.show();
          return;
        }

        this.isLoading = true;

        try {
          let response = await this.$axios.post(`users/me/subscription/initiate`, {
            cancelUrl: window.location.origin + this.$route.path + '?iufa=cancel',
            successUrl: window.location.origin + this.$route.path + '?iufa=success&scsi=CHECKOUT_SESSION_ID',
          });

          if (response.data.data.hasActiveSubscription) {
            fbq('track', 'StartTrial');
            ga('send', 'event', 'start_trial');

            this.$store.commit('MERGE_AUTH', {
              user: { hasActiveSubscription: response.data.data.hasActiveSubscription },
            });

            alert('You already subscribed.');
            await this.hide();
            return;
          }

          window.location.href = response.data.data.checkoutUrl;
        } catch (error) {
          this.isLoading = false;
          throw error;
        }
      },
    },
  };
</script>

<style lang="scss">
  .i-unlock-full-access {
    position: fixed;
    z-index: 1000;
    top: 0;
    right: 0;
    bottom: 0;
    left: 0;
    display: flex;
    flex-direction: column;
    align-items: center;
    justify-content: flex-end;
    visibility: visible;
    opacity: 1;
    transition: visibility 0.25s ease-in, opacity 0.25s ease-in;

    &:not(&--shown) {
      visibility: hidden;
      opacity: 0;
    }
  }

  .i-unlock-full-access__background {
    position: absolute;
    z-index: 1;
    top: 0;
    right: 0;
    left: 0;
    bottom: 0;
    background-color: rgba(#07071c, 50%);
  }

  .i-unlock-full-access__wrapper {
    position: relative;
    z-index: 2;
    display: flex;
    flex-direction: column;
    width: 100%;
    max-height: 100%;
    overflow-y: auto;
    transform: translateY(0);
    transition: transform 0.25s ease-in;
  }

  .i-unlock-full-access:not(.i-unlock-full-access--shown) .i-unlock-full-access__wrapper {
    transform: translateY(100%);
  }

  .i-unlock-full-access__content {
    position: relative;
    width: 100%;
    max-width: 480px;
    border-top-left-radius: rs(16px);
    border-top-right-radius: rs(16px);
    background-color: #fff;
    margin: 0 auto;
    padding: 0 rs(32px);
  }

  .i-unlock-full-access-checking {
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;
    padding: rs(20px) 0;
    text-align: center;
  }

  .i-unlock-full-access-checking__title {
    font-size: rs(16px);
  }

  .i-unlock-full-access-checking__image {
    width: rs(50px);
    height: rs(50px);
    margin-top: rs(15px);
  }

  .i-unblock-full-access__terms {
    display: flex;
    align-items: center;
    justify-content: center;
    margin-top: rs(24px);
    margin-bottom: rs(40px);
    opacity: 0.5;
  }

  .i-unblock-full-access__term {
    font-size: rf(14px);
    color: #07071c;
    text-decoration: none;
  }

  .i-unblock-full-access__term-separator {
    width: rs(3px);
    height: rs(3px);
    border-radius: 50%;
    background-color: #07071c;
    margin: 0 rs(8px);
  }

  .i-unblock-full-access__circles {
    position: absolute;
    z-index: 0;
    left: 0;
    right: 0;
    bottom: 0;
    height: rs(293px);
    overflow: hidden;
    pointer-events: none;
  }

  // VARIANT 0

  .i-unlock-full-access--variant-0 .i-unlock-full-access__title {
    font-size: rf(24px);
    color: #07071c;
    font-weight: bold;
    margin-top: rs(25px);
    text-align: center;
  }

  .i-unlock-full-access--variant-0 .i-unlock-full-access__cross {
    position: absolute;
    z-index: 1;
    top: rs(20px);
    right: rs(20px);
    width: rs(34px);
    height: rs(34px);
    background-image: url('~assets/images/i-unlock-full-access-cross.svg');
    background-repeat: no-repeat;
    background-size: rs(24px);
    background-position: center;
    background-color: transparent;
    border: 0;
    cursor: pointer;
  }

  .i-unlock-full-access--variant-0 .i-unlock-full-access__details {
    margin-top: rs(39px);
  }

  .i-unlock-full-access--variant-0 .i-unlock-full-access__detail {
    background-image: url('~assets/images/unlock-full-access-check.svg');
    background-size: rs(16px);
    background-repeat: no-repeat;
    background-position: center left;
    font-size: rf(16px);
    color: rgba(#07071c, 80%);
    padding-left: rs(16px + 12px);

    &:not(:first-child) {
      margin-top: rs(20px);
    }
  }

  .i-unlock-full-access--variant-0 .i-unlock-full-access__description {
    text-align: center;
    font-size: rf(16px);
    color: #fb7474;
    font-weight: bold;
    margin-top: rs(44px);
    margin-bottom: rs(44px);
  }

  // VARIANT 1

  .i-unlock-full-access.i-unlock-full-access--variant-1 .i-unlock-full-access__wrapper {
    flex-grow: 1;
  }

  .i-unlock-full-access.i-unlock-full-access--variant-1 .i-unlock-full-access__content {
    padding: 0;
    border-radius: 0;
    flex-grow: 1;
  }

  .i-unlock-full-access--variant-1 .i-unlock-full-access__overlay {
    display: flex;
    flex-direction: column;
    align-items: center;
    background: linear-gradient(73deg, #fb7474 -11.09%, #ffb15e 117.13%);
    border-bottom-left-radius: rs(40px);
    border-bottom-right-radius: rs(40px);
    padding-top: rs(15px);
    padding-bottom: rs(100px);
  }

  .i-unlock-full-access--variant-1 .i-unlock-full-access__image {
    height: rs(70px);
  }

  .i-unlock-full-access--variant-1 .i-unlock-full-access__title {
    font-size: rf(28px);
    font-weight: 700;
    color: #fff;
    margin-top: rs(10px);
    text-align: center;
  }

  .i-unlock-full-access--variant-1 .i-unlock-full-access__description {
    font-size: rf(16px);
    line-height: rs(22px);
    color: #fff;
    margin-top: rs(8px);
    text-align: center;
    margin-left: rs(32px);
    margin-right: rs(32px);
  }

  .i-unlock-full-access--variant-1 .i-unlock-full-access-info {
    position: relative;
    height: rs(132px);
  }

  .i-unlock-full-access--variant-1 .i-unlock-full-access-info__content {
    position: relative;
    z-index: 1;
    background-color: #fff;
    border-radius: rs(10px);
    margin-left: rs(32px);
    margin-right: rs(32px);
    margin-top: rs(-83px);
    padding: rs(24px);
  }

  .i-unlock-full-access--variant-1 .i-unlock-full-access-info__shadow {
    position: absolute;
    z-index: 0;
    bottom: 0;
    left: 50%;
    transform: translate(-50%, 5px);
    width: 85%;
    height: 45%;
    background: rgba(#fb7474, 30%);
    filter: blur(50px);
    border-radius: 20px;
  }

  .i-unlock-full-access--variant-1 .i-unlock-full-access-info__title {
    font-size: rf(24px);
    font-weight: bold;
    line-height: rs(32px);
  }

  .i-unlock-full-access--variant-1 .i-unlock-full-access-info__tag {
    position: absolute;
    z-index: 1;
    top: rs(24px);
    right: rs(24px);
    display: flex;
    justify-content: center;
    align-items: center;
    width: rs(66px);
    height: rs(28px);
    background-color: rgba(#fb7474, 10%);
    border-radius: rs(4px);
    color: #fb7474;
    font-size: rf(14px);
  }

  .i-unlock-full-access--variant-1 .i-unlock-full-access-info__description {
    line-height: rs(20px);
    font-size: rf(14px);
    color: rgba(#07071c, 80%);
    margin-top: rs(12px);

    .highlighted {
      color: #fb7474;
      font-weight: bold;
      white-space: nowrap;
    }
  }

  .i-unlock-full-access--variant-1 .i-unlock-full-access__details {
    padding: 0 rs(32px);
    margin-top: rs(26px);
  }

  .i-unlock-full-access--variant-1 .i-unlock-full-access-detail {
    display: flex;
    align-items: center;

    &:not(:first-child) {
      margin-top: rs(12px);
    }
  }

  .i-unlock-full-access--variant-1 .i-unlock-full-access-detail__image {
    width: rs(32px);
    height: rs(32px);
  }

  .i-unlock-full-access--variant-1 .i-unlock-full-access-detail__title {
    font-size: rs(14px);
    color: rgba(#07071c, 80%);
    margin-left: rs(16px);
  }

  .i-unlock-full-access--variant-1 .i-unlock-full-access__button-wrapper {
    padding-left: rs(32px);
    padding-right: rs(32px);
    margin-top: rs(20px);
  }

  .i-unlock-full-access--variant-1 .i-unlock-full-access__decorations {
    position: absolute;
    z-index: 0;
    top: rs(10px);
    width: 95%;
  }

  // VARIANT 2

  .i-unlock-full-access--variant-2 .i-unlock-full-access__title {
    font-size: rf(24px);
    color: #07071c;
    font-weight: bold;
    margin-top: rs(25px);
    text-align: center;
  }

  .i-unlock-full-access--variant-2 .i-unlock-full-access__cross {
    position: absolute;
    z-index: 1;
    top: rs(20px);
    right: rs(20px);
    width: rs(34px);
    height: rs(34px);
    background-image: url('~assets/images/i-unlock-full-access-cross.svg');
    background-repeat: no-repeat;
    background-size: rs(24px);
    background-position: center;
    background-color: transparent;
    border: 0;
    cursor: pointer;
  }

  .i-unlock-full-access--variant-2 .i-unlock-full-access__details {
    margin-top: rs(25px);
  }

  .i-unlock-full-access.i-unlock-full-access--variant-2 .i-unlock-full-access__detail {
    background-image: url('~assets/images/unlock-full-access-check.svg');
    background-size: rs(16px);
    background-repeat: no-repeat;
    background-position: center left;
    font-size: rf(16px);
    color: rgba(#07071c, 80%);
    padding-left: rs(16px + 12px);

    &:not(:first-child) {
      margin-top: rs(20px);
    }
  }

  .i-unlock-full-access--variant-2 .i-unlock-full-access-info {
    position: relative;
    border: rs(1px) solid #fb7474;
    border-radius: rs(10px);
    padding: rs(20px);
    margin-top: rs(32px);
    margin-bottom: rs(32px);
  }

  .i-unlock-full-access--variant-2 .i-unlock-full-access-info__title {
    color: #07071c;
    font-size: rs(18px);
    font-weight: bold;
  }

  .i-unlock-full-access--variant-2 .i-unlock-full-access-info__stars {
    position: absolute;
    top: rs(20px);
    right: rs(20px);
    display: flex;
    align-items: center;
    height: rs(24px);
  }

  .i-unlock-full-access--variant-2 .i-unlock-full-access-info__star {
    width: rs(16px);
    height: rs(16px);

    &:not(:first-child) {
      margin-left: rs(4px);
    }
  }

  .i-unlock-full-access--variant-2 .i-unlock-full-access-info__separator {
    background-color: #f1f1f1;
    width: 100%;
    height: rs(1px);
    margin-top: rs(20px);
  }

  .i-unlock-full-access--variant-2 .i-unlock-full-access-info__steps {
    margin-top: rs(20px);
  }

  .i-unlock-full-access--variant-2 .i-unlock-full-access-info__step {
    display: flex;
    align-items: center;

    &::before {
      display: inline-block;
      content: '';
      width: rs(4px);
      height: rs(4px);
      background-color: #fb7474;
      border-radius: 50%;
      margin-right: rs(8px);
    }

    &:not(:first-child) {
      margin-top: rs(16px);
    }

    .highlighted {
      color: #fb7474;
      font-weight: bold;
      white-space: nowrap;
    }
  }
</style>
